'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var currentFocusedModel = '';

function handleFocus(fieldValue, node) {
  if (!fieldValue) return;

  if (fieldValue.focus) {
    if (currentFocusedModel !== fieldValue.model) {
      if (document && document.activeElement !== node && node.focus) {
        currentFocusedModel = fieldValue.model;
        node.focus();
      }
    }
  }
}

handleFocus.clearCache = function () {
  return currentFocusedModel = '';
}; // eslint-disable-line no-return-assign

exports.default = handleFocus;